// stdafx.h : include file for standard system include files,
//  or project specific include files that are used frequently, but
//      are changed infrequently
//

#if !defined(AFX_STDAFX_H__1C162607_6C55_436A_912E_018942733467__INCLUDED_)
#define AFX_STDAFX_H__1C162607_6C55_436A_912E_018942733467__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifdef _WIN_
#define CPP_2005
#ifdef CPP_2005
#pragma warning ( disable : 4996 )
#pragma warning ( disable : 4018 )
#endif
#endif

// TODO: reference additional headers your program requires here
#include <stdio.h>
#include <string.h>
#include <math.h>
//#include <vector>
//using namespace std;

typedef const char* LPCSTR;
typedef char* LPSTR;
typedef const char* LPCTSTR;
typedef char* LPTSTR;

#if defined(_WIN_) && !defined(_WIN_MPICH)
//#define _WIN_
//#define CLUSTER_WIN_OUR
#endif
#if !defined(_WIN_) || defined(_WIN_MPICH)
#define _UNIX_
#define CLUSTER_LAM_MPI
#endif

#if defined (_WIN_) || defined(_WIN_MPICH)
#include <windows.h>
#define copysign _copysign
typedef __int64 int64;
typedef int intptr_t;
#else
//typedef LONG32 int64;
#endif // _WIN_

#ifndef min
#define min(a, b)  (((a) < (b)) ? (a) : (b)) 
#endif
#ifndef __min
#define __min min
#endif
#ifndef max
#define max(a, b)  (((a) > (b)) ? (a) : (b)) 
#endif
#ifndef __max
#define __max max
#endif
#ifndef _T
#define _T(x)	x
#endif
#ifndef ASSERT
#define ASSERT(x)	
#endif
#ifndef COF
#define	COF(_a_)		(sizeof(_a_)/sizeof(_a_[0]))
#endif
#ifndef LOF
#define	LOF(_b_)		(COF(_b_)-1)
#endif

#ifndef M_SQRT2
#define M_SQRT2     1.41421356237309504880
#endif
#ifndef M_1_PI
#define M_1_PI      0.318309886183790671538
#endif
#ifndef M_PI
#define M_PI        3.14159265358979323846
#endif
#ifndef M_PI_2
#define M_PI_2      1.57079632679489661923
#endif

#ifndef _MAX_PATH
#define _MAX_PATH	256
#endif
#ifndef _MAX_FNAME
#define _MAX_FNAME	80
#endif
#ifndef _MAX_EXT
#define _MAX_EXT	80
#endif

#ifndef INT64
#define INT64 int64
#endif //INT64

#define _USE_FOPEN

#ifndef INT32
typedef int int32;
#define INT32 int32
#endif //INT32

#if !defined( WIN32) || defined(_WIN_MPICH)

#ifndef BYTE
typedef unsigned char byte;
#define BYTE byte
#endif //BYTE

#ifndef UINT
typedef unsigned int uint;
#define UINT uint
#endif //UINT

#ifndef BOOL
typedef int ibool;
#define BOOL ibool
#endif //BOOL

#ifndef WORD
typedef unsigned short word;
#define WORD word
#endif //WORD

#ifndef DWORD
typedef unsigned int dword;
#define DWORD dword
#endif //DWORD

#ifndef NULL
#define NULL	((void *)0)
#endif //NULL

#ifndef FALSE
#define FALSE	0
#endif //FALSE 

#ifndef TRUE
#define TRUE	1
#endif //TRUE

#endif //WIN32

// TODO: reference additional headers your program requires here
#define DOUBLE_EMPTY		-9999.99
#define FLOAT_EMPTY			float(-9999.99)
#define INT_EMPTY			-9999
#define UINT_EMPTY			-1
#define SIZE_OF_FLOAT		int( sizeof(float) )
#define SIZE_OF_INT			int( sizeof(int) )
#define OCHEN_MALO			1.e-10
#define OCHEN_MNOGO			1.e10

#define UNDEF_VAL			DOUBLE_EMPTY
#define unlink(x)	remove(x)

#include "Preprocessor.h"

#ifndef U_SLASH
#ifdef _WIN_
#define U_SLASH  '\\'
#else
#define U_SLASH  '/'
#endif
#endif
		

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_STDAFX_H__1C162607_6C55_436A_912E_018942733467__INCLUDED_)
